/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */

package com.jcg.multivaluehashmapexample;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 *
 * @author omozegieaziegbe
 */
public class MultiValueHashMapExample {

    public static void main(String[] args) {
        Map<String, ArrayList<String>> multiValueMap = new HashMap<String, ArrayList<String>>();

        // Add values to the map
        multiValueMap.computeIfAbsent("Thomas", k -> new ArrayList<>()).add("The Age of Reason");
        multiValueMap.computeIfAbsent("Thomas", k -> new ArrayList<>()).add("Common Sense");
        
        // Adding values for another key
        multiValueMap.computeIfAbsent("Charles", k -> new ArrayList<>()).add("A Tale of Two Cities");
        multiValueMap.computeIfAbsent("Charles", k -> new ArrayList<>()).add("Great Expectations");

        // Retrieving values associated with a key
        List<String> thomasBooks = multiValueMap.get("Thomas");
        List<String> charlesBooks = multiValueMap.get("Charles");
        
        System.out.println("Thomas Books: " + thomasBooks);
        System.out.println("Charles Books: " + charlesBooks);
    }
}
